/*  Elektronikberechnungsroutinen  File: ELECFORM.C  
    thomas schaerer   turbo-c     > apr-90
    
    Damit eine sptere Portierung nicht unendlich aufwendig wird,
    werden hier keine selbstgebastelten externen Objectcodes wie es
    in z.B.'myapplic.o' enthalten ist verwendet. Diese sind ebenfalls
    als Funktionen hier enthalten. Auch speziell bentigte Definitionen
    aus 'myheadr.h' sind hier neu definiert.
------------------------------------------------------------------------  */

#include <tos_head.h>


#define c_volt(v)       log(1./(1.-v))         /* Ladespannungsdefinition */
#define kreisfrq(f)     (2*PI*f)               /* Kreisfrequenzdefinition */
#define r_toler(e_reihe)    pow(10.,(log10(10.)/e_reihe))

                       /* Prototypen (Vordeklar.), man kann nie wissen... */
void catchkey(void);
void div_zero(void);
void inp_quest(void);
void repeat_quest(int n);
void break_quest(int n);
void result_blindw(double result, char gesucht);
void time1(double v);
void resist(double v);
void capac(double v);
void blindw(void);
void c_voltage(void); 
void par_res(void);
void slew_rate(void);
void r_toleranz(void);
void write_r_toler(int e_reihe, int toler, double e_step);
void netzteil(void);
void next_calc(int n);
void netzt_1_auswertung(double v_max, double v_mit, double v_min, 
                        double vsek_n, double p_trf);
void netzt_2_auswertung(double v_ss, double ri, double vsek_o, 
                        double c_lad, double v_reg, double v_drop, 
                        double i_last, double netztol_p);


char key = 0;                             /* Einzige globale Deklaration! */


/**************************************************************************/
/*                Allgemein benutzte Funktionen                           */


void test(void)   { bell(TRUE);   getch(); }    /* Wenn's nicht geht... */


void catchkey(void)               /* Abfangen illegaler Tastbettigungen */
{
  long k;
  do
  {
    k=Cconis();
    if (k==-1)    Crawcin();
  }
  while(k==-1);
}  



void div_zero(void)             
{
  cls();
  stor_curs();
  revrs_curs();
  pos_curs(9,15);   puts("                                             ");
  pos_curs(10,15);  puts("  Falsche Eingabe:  Division durch Null !!!  ");
  pos_curs(11,15);  puts("  ----------------                           ");
  pos_curs(12,15);  puts("                                             ");
  norm_curs();
  bell(TRUE);
  repeat_quest(ON);
  break_quest(ON);
  key =  getch();
  restor_curs();
  cls();
}


/* Speziell fr Kondensatorspannung als Funktion von T, R und C. */
void inp_quest(void)    
{
  stor_curs();
  revrs_curs();
  pos_curs(22,0);   puts("   Gesucht wird ...:   Taste 'g'.         ");
  pos_curs(23,0);   puts("   Neue Zeitkonst. :   Taste 'n'.         ");
  norm_curs();      
  restor_curs();
}


void next_calc(int n)
{
  stor_curs();
  
  switch(n)
  {
    case 1: revrs_curs();   pos_curs(22,0);
            puts("   Weitere Berechn.:   Taste 'w'.         ");           
            norm_curs();       break;   
    case 0: clr_line_yx(22,0); break;
  }
  
  restor_curs();
}




void repeat_quest(int n)
{
  stor_curs();

  switch(n)
    {
    case 1:   revrs_curs();   pos_curs(23,0);
              printf("   Repetition:         Irgend eine Taste. ");
              norm_curs();       break;
    case 0:   clr_line_yx(23,0); break;
    }
    
   restor_curs();
}



void break_quest(int n)
{
  stor_curs();

  switch(n)
  {
    case 1:   revrs_curs();   pos_curs(24,0);
              printf("   Abbruch:            Taste 'q'.         ");
              norm_curs();    break;
    case 0:   clr_line_yx(24,0);    break;
  }
  
  restor_curs();
}


/**************************************************************************/
/*           Den Hauptprogrammteilen zugehrigen Funktionen.              */


void result_blindw(double result, char gesucht)
{                         
  char *unit;

  if(result >= 1000000L)    {  result /= 1000000L;  unit=" M-Ohm "; }
  else if(result >= 1000)   {  result /= 1000;      unit=" K-Ohm "; }
  else                      {                       unit=" Ohm ";   }
  revrs_curs();
  pos_curs(18,29);
  if(gesucht == 'L')           printf(" X(L) =  ");
  else if(gesucht == 'C')      printf(" X(C) =  ");
  printf("%4.3lf %s\n",result,unit);                 
  norm_curs();                            
}



void time1(double v)            /* Gehrt zum Hauptprogrammteil 'c_volt'. */
{
  double r, c, charge_time1;                             
  int error;

  do
  {
    cls();    puts("");     revrs_curs();
    puts("                                                        ");
    puts("      T = R * C * log ( 1 / ( 1 - V ) )   sec           ");
    puts("                                                        ");
    norm_curs();    pos_curs(6,0);
    printf(" V = Verhltnis von  U(C)/U =  %lf\n",v);
    
    do
    {
      pos_curs(8,0);    
      printf(" R (in k-Ohm)   = ");
      ena_curs();
      error = !scanf("%lf",&r);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    do
    {
      pos_curs(9,0);    
      printf(" C (in %c-Farad) = ",MUE);
      ena_curs();
      error = !scanf("%lf",&c);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    
    r *= 1000;                   /* weil Eingabe in k-Ohm */
    c/=1000000L;               /* weil Eingabe in y-Farad */
    puts("");   puts("");
    charge_time1 = (r * c * c_volt(v)) * 1000;    /* Ladezeit in m-sec */         
    printf("Ladezeit T =  ");

    if(charge_time1 < 0.001)                              
    {
      charge_time1 *= 1000000L;
      printf("%4.3lf n-sec",charge_time1);
    }
    else if(charge_time1<1)
    {
      charge_time1 *= 1000;
      printf("%4.3lf %c-sec",charge_time1,MUE);
    }
    else if(charge_time1<1000)
    {
      printf("%4.3lf m-sec",charge_time1);
    }
    else
    {
      charge_time1 /= 1000;

      if(charge_time1 < 60)     printf("%4.3lf sec",charge_time1);
      else
      {
        printf("%4d min",(int)(charge_time1/60));       /* Aufteilung in */
        printf(" %2d sec",(int)(fmod(charge_time1,60))); /* Min. und Sek. */
      }
    }

    inp_quest();
    repeat_quest(ON);
    break_quest(ON);
    key = getch();
  }
  while(key!='q' && key!='n' && key!='g');
}



                        
void resist(double v)           /* Gehrt zum Hauptprogrammteil 'c_volt'. */
{
  double t, c, res;
  int error;
  
  do
  {
    cls();    puts("");   revrs_curs();   
    puts("                                                        ");
    puts("      R = T / ( C * log ( 1 / ( 1 - V ) ) )   Ohm       ");
    puts("                                                        ");
    norm_curs();
    pos_curs(6,0);
    printf(" V = Verhltnis von  U(C)/U =  %lf\n",v);
 
    do
    {
      pos_curs(8,0);    
      printf(" T (in m-sec)   = ");
      ena_curs();
      error = !scanf("%lf",&t);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    do
    {
      pos_curs(9,0);    
      printf(" C (in %c-Farad) = ",MUE);
      ena_curs();
      error = !scanf("%lf",&c);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    t /= 1000;                /* weil Eingabe in m_sec   */
    c /= 1000000L;             /* weil Eingabe in y-Farad */
    puts("");   puts("");
    res = t / (c * c_volt(v));           /* Widerst. in Ohm */
    revrs_curs();
    printf(" Widerstand R =  ");

    if(res>1000000L)
    {
      res /= 1000000L;
      printf("%4.3lf M-Ohm",res);
    }
    else if(res>1000)
    {
      res /= 1000;
      printf("%4.3lf k-Ohm",res);
    }
    else 
    {
      printf("%4.3lf Ohm",res);
    }

    pos_curs(22,0);   puts("   Neue Zeiteingabe:  Taste 'n'.   ");
    inp_quest();
    repeat_quest(ON);
    break_quest(ON);
    key = getch();
  }
  while(key!='q' && key!='n' && key!='g');
}




void capac(double v)            /* Gehrt zum Hauptprogrammteil 'c_volt'. */
{
  double t, r, cap;
  int error;
  
  do
  {
    cls();    puts("");   revrs_curs();
    puts("                                                        ");
    puts("      C = T / ( R * log ( 1 / ( 1 - V ) ) )   Farad     ");
    puts("                                                        ");
    norm_curs();
    pos_curs(6,0);
    printf(" V = Verhltnis von  U(C)/U =  %lf\n",v);

    do
    {
      pos_curs(8,0);    
      printf(" T (in m-sec)   = ");
      ena_curs();
      error = !scanf("%lf",&t);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    do
    {
      pos_curs(9,0);    
      printf(" R (in k-Ohm)   = ");
      ena_curs();
      error = !scanf("%lf",&r);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    r *= 1000;              /* weil Eingabe in k-Ohm */
    t /= 1000 ;             /* weil Eingabe in m-sec */
    puts("");   puts("");
    cap = t / (r *  c_volt(v)) * 1000000L;      /* cap in y-Farad */
    revrs_curs();
    printf(" Kapazitt C =  ");

    if(cap < 1/100)
    {
      cap *= 1000000L;                             
      printf("%4.3lf p-Farad",cap);
    }
    else if(cap < 1)
    {
      cap *= 1000;
      printf("%4.3lf n-Farad",cap);
    }
    else 
    {
      printf("%4.3lf %c-Farad",cap,MUE);
    }

    pos_curs(22,0);   puts("   Neue Zeiteingabe:  Taste 'n'.   ");
    inp_quest();
    repeat_quest(ON);
    break_quest(ON);
    key = getch();
  }
  while(key!='q' && key!='n' && key!='g');
}




void write_r_toler(int e_reihe,int toler,double e_step)
{
  int i, x = 5, y = 3;
  double r_norm = 10, r_norm_disp;

  cls();
  pos_curs(0,0);
  revrs_curs();
  printf("   E-%d  (Toleranz = %d %%)  ",e_reihe, toler);
  norm_curs();

  for(i=0;  i<=e_reihe; i++)
  {                                          /* Korrektur fr Normtabelle */
    if(toler>=5 && (r_norm>=26 && r_norm<=48))      r_norm_disp = r_norm+1;
    else if(toler>=5 &&(r_norm>=82 && r_norm<=84))  r_norm_disp = r_norm-1;
    else                                            r_norm_disp = r_norm;

    pos_curs(y,x);                               /* Nchster Tabellenwert */

    if(toler<=2)    printf("%3.1lf",r_norm_disp);   
    else            printf("%3.0lf",r_norm_disp);

    x += 15;                            /* Nchste Spalte                 */
    if(x==80)   { x = 5;    y++;  }     /* Nchste Zeile                  */
    r_norm *= e_step;                   /* Nchster Normwert, unkorigiert */
  }

  revrs_curs(); 
  pos_curs(24,0);     printf(" Weiter: <Taste>  / Abbruch: 'q'    ");  
  norm_curs();
  key = getch();
}




void netzt_1_auswertung(double v_max, double v_mit, double v_min, 
                        double vsek_n, double p_trf)
{
  printf(" Maximale Gleichspannung am Ladeelko:  %3.3lf V\n",v_max);
  printf(" Mittlere Gleichspannung am Ladeelko:  %3.3lf V\n",v_mit);    
  printf(" Minimale Gleichspannung am Ladeelko:  %3.3lf V\n",v_min);
  printf(" Trafo-Nennleistung:                   %4.2lf W\n",p_trf);
  printf(" Trafo-Sekundrspannung bei Nennlast:  %3.3lf Veff\n",vsek_n);
}



void netzt_2_auswertung(double v_ss, double ri, double vsek_o, 
                        double c_lad, double v_reg, double v_drop, 
                        double i_last, double netztol_p)
{
  printf(" Trafo-Sekundrspannung im Leerlauf:   %3.3lf Veff\n",vsek_o);
  printf(" Trafo-Innenwiderstand:                %3.4lf Ohm\n",ri);
  printf(" Kapazitt des Ladekondensators:       %5.2lf %cF",c_lad,MUE);
  puts("  <--- ");
  revrs_curs();
  puts("\n\n Wiederholung der eingegeben Daten ....  \n");  
  norm_curs();
  printf(" Ausgangsspannung des Spannungsreglers:  %3.3lf V\n",v_reg);
  printf(" Dropoutspannung  des Spannungsreglers:  %3.3lf V\n",v_drop);
  printf(" Wahl der Rippelspannung am Ladeelko:    %3.3lf V\n",v_ss);
  printf(" Laststrom am Reglerausgang:             %3.3lf A\n",i_last);
  printf(" Netzspannungstoleranz (%%):          - %3.1lf %%\n",netztol_p);
}



double verlustf_tabelle(double p_trf)
{
  static int tab[]={4,10,15,20,30,33,50,55,75,80,100,105,135,150,195,
                    200,300};
  int error, zeile, spalte, i;
  double verlustf;

  pos_curs(5,0);
  puts(" Mantelkern- oder Ringkerntrafo, das ist hier die Frage....\n\n");  
  puts(" Die folgende Verlustfaktortabelle ist aus HALBLEITER-SCHALTUNGS-");
  puts(" TECHNIK von Tietze/Schenk, 9.Auflage  Seite 535\n\n\n           ");
  puts(" Der Ringkerntrafo hat einen etwas hheren Verlustfaktor als der ");
  puts(" Mantelkerntrafo. Dafr ist er wesentlich leichter, kleiner im   ");
  puts(" Volumen und streut viel weniger Magnetfelder in der Gegend      ");
  puts(" herum.                                                          ");
  next_side();      /* Makro */
  getch();
  cls_yx(2,0);    
  printf(" Trafo - Nennleistung (W)= ");   
  revrs_curs();  printf(" %4.2lf",p_trf);   
  pos_curs(4,0);
  puts("      Nennleistung    Mantelkerntrafo    Rigkerntrafo          ");
  puts("      -----------------------------------------------          ");
  puts("           4 W            1.31 (M42)                           ");
  puts("          10 W                               1.18 (60 mm)      ");
  puts("          15 W            1.20 (M55)                           ");
  puts("          20 W                               1.18 (61 mm)      ");
  puts("          30 W                               1.16 (70 mm)      ");
  puts("          33 W            1.14 (M65)                           ");
  puts("          50 W                               1.15 (80 mm)      ");
  puts("          55 W            1.11 (M74)                           ");
  puts("          75 W                               1.12 (94 mm)      ");
  puts("          80 W            1.09 (M85a)                          ");
  puts("         100 W                               1.11 (95 mm)      ");
  puts("         105 W            1.06 (M85b)                          ");
  puts("         135 W            1.07 (M102a)                         ");
  puts("         150 W                               1.09 (100 mm)     ");
  puts("         195 W            1.05 (M102b)                         ");
  puts("         200 W                               1.08 (115 mm)     ");
  puts("         300 W                               1.07 (120 mm)     ");
    /* Es geht auch ohne die vielen 'puts', aber das stinkt mir ! */

  if(p_trf <= 300)
  {   
    for(i=0;i<sizeof(tab)/sizeof(int);i++)      /* Zeiger zeigt auf den */
      if(p_trf <= tab[i])    break;             /* nchsthheren Trafo- */
    zeile = i + 6;                              /* Leistungstyp.        */

    spalte = 4;
    pos_curs(zeile,spalte); puts("--->");

    zeile = 4;    spalte = 64;
    norm_curs();
    pos_curs(zeile,spalte);     puts("Man beachte den");
    pos_curs(zeile+1,spalte);   puts("Zeiger auf die ");
    pos_curs(zeile+2,spalte);   puts("nchst grssere");
    pos_curs(zeile+3,spalte);   puts("Trafoleistung !");
    do
    {
      clr_line_yx(23,0);
      printf(" Eingabe des Formfaktores:  ");
      ena_curs();
      error = !scanf("%lf",&verlustf);
      rewind(stdin);
      dis_curs();
    }
    while(bell(error || verlustf <= 1));
  }
  else
  {
    pos_curs(24,0); 
    printf("Trafoleistung ausserhalb der Tabelle!  Drcke Taste.");
    bell(TRUE);
    getch();
    verlustf = 0;       /* Null, damit die Resultate nicht erscheinen */
  }

  return(verlustf);
}


/**************************************************************************/
/************    P r o g r a m m  -  F U N K T I O N E N   ****************/

void netzteil(void)
{
  int error;
  double v_reg=0, v_drop=0, v_ss=0, v_min, v_max, v_mit, i_last=0, vsek_n, 
          vsek_o, vd, p_trf, formfk, ri = 0, c_lad, verlustf, netztol_p;
          
          /*  v_reg     = Ausgangsspannung des Spannungsregler
              v_drop    = Minimaler Spannungsabfall ber Spannungsregler
              v_ss      = Peak-Peak-Rippelspannung ber Ladeelko
              v_min     = Minimaler Wert der Gleichspannung ber Elko
              v_mit     = Mittlerer Wert der Gleichspannung ber Elko
              v_mit     = Maximaler Wert der Gleichspannung ber Elko
              i_last    = DC-Laststrom (mittl. Wert vor dem Regler)
              vsek_n    = Trafo-Sekundr-Nennspannung
              vsek_o    = Trafo-Sekundr-Leerlaufspannung
              vd        = Diodenfluss-Spannung einer Si-Leistungsdiode
              p_trf     = Nennleistung des Trafo
              formfk    = Formfaktor (Minimalwert therm. Grenze ~ 1.2)  
              ri        = Innenwiderstand der Trafo-Sekundrwicklung
              c_lad     = Kapazitt des Ladekondensators
              verlustf  = Verlustfaktor des Trafo
              netztol_p = Netztoleranz in Prozent (U Netz - netztol_p)
          */
          
          
  vd = 0.8;      /* Realistischer Wert, wenn die Diode 1/2 belastet ist */
  formfk = 1.5;  /* Empfohlener Richtwert fr Doppelweggleichrichtung   */

  do
  { 
    cls();
    revrs_curs();
    puts("    Berechnung eines Linear-Netzteiles (Trafo, Gleichrichter, Regler).    ");
    norm_curs();
    pos_curs(2,0);
    puts(" Brcken - Schaltung:          Taste 'b'.");
    puts(" Mittelpunkt - Schaltung:      Taste 'm'.");
    break_quest(ON);
  
    do  { key = getch(); }    while(key!='b' && key!='m' && key!='q');
    break_quest(OFF);
    cls_yx(2,0);
    revrs_curs();
    if(key=='b')        puts(" Wahl:  Brcken - Schaltung ! ");
    else if(key=='m')   puts(" Wahl:  Mittelpunkt - Schaltung ! ");
    norm_curs();
  
    if(key=='b' || key=='m')
    {
      do
      {
        ena_curs();
        cls_yx(4,0);  
        printf(" Ausgangsspannung des Spannungsreglers (V):  ");
        error = !scanf("%lf",&v_reg);
        printf(" Dropoutspannung  des Spannungsreglers (V):  ");
        error = !scanf("%lf",&v_drop);
        printf(" Laststrom am Reglerausgang (A):             ");
        error = !scanf("%lf",&i_last);
        printf(" Wahl der Rippelspannung am Ladeelko (V):    ");
        error = !scanf("%lf",&v_ss);
        printf(" Netzspannungstoleranz [U Netz - ?%%] (%%):    ");
        error = !scanf("%lf",&netztol_p);
        dis_curs();
        rewind(stdin);
      }
      while(bell(error || v_reg==0 || v_drop==0 || i_last==0 || v_ss==0 )); 

      puts("-------------------------------------------------------\n");

      v_min = v_reg + v_drop;               /* Minimale Gleichspannung  */
      v_max = v_min + v_ss;                 /* Maximale Gleichspannung  */
                  
          /* Minimale Sekundrspannung gegeben durch Regler und Gleichr.*/
      if(key=='b')          vsek_n = (v_max + 2 * vd) / sqrt(2);
      else if(key=='m')     vsek_n = (v_max + vd) / sqrt(2);

          /* Reale Sekundrspannung gegeben durch Netzspannungstoleranz */
      vsek_n *=  1. / (1. - (netztol_p / 100.));

      if(key=='b')                                    /* Brckenschaltung */
      {           
        v_max = (vsek_n * sqrt(2)) - 2 * vd;
        v_min = v_max - v_ss;                 /* Minimale Gleichspannung  */
        v_mit = v_min + (v_ss * 2 / 3);       /* Mittlere Gleichspannung  */
        p_trf = formfk * i_last * (v_mit + 2 * vd);/* Trafo-Sek. Leistung */
      }
      else if(key=='m')                           /* Mittelpunktschaltung */
      {
        v_max = (vsek_n * sqrt(2)) - vd;
        v_min = v_max - v_ss;                 /* Minimale Gleichspannung  */
        v_mit = v_min + (v_ss * 2 / 3);       /* Mittlere Gleichspannung  */
        p_trf = formfk * i_last * (v_mit + vd);   /* Trafo-Sek. Leistung  */
      }

      netzt_1_auswertung(v_max, v_mit, v_min, vsek_n, p_trf);                 
    
      next_calc(ON);      /* Taste 'w'   */   
      repeat_quest(ON);   /* Any Key     */
      break_quest(ON);    /* Taste 'q'   */
      key = getch();
    }
    
    
    if(key=='w')        /* Es geht weiter mit der Ri-Berechnung des Trafo */
    {
      cls_yx(2,0);    key=0;
      puts(" Trafo vorhanden und gemessen?     Tasten 'j' oder 'n'.");
      do  { key = getch(); } while(key!='j' && key!='n');
      
      if(key=='n')                         /* Verlustfaktor des Trafo ... */
      { 
        cls_yx(2,0);  
        verlustf = verlustf_tabelle(p_trf);  /* Verlustfaktor aus Tabelle */
        cls_yx(2,0);
      }
      else 
      { 
        clr_line_yx(2,0);
        puts(" Eingabe des Verlustfaktores:               Taste 'f'.");
        puts(" Eingabe der Sekundr-Leerlaufspannung:     Taste 'v'.");
        do { key = getch(); } while(key!='f' && key!='v');  
        
        if(key=='f')
        {
          do
          {
            clr_line_yx(5,0);
            printf(" Verlustfaktor =  ");
            ena_curs();
            error = !scanf("%lf",&verlustf);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error || verlustf <= 1));
          
        }
        else
        {
          do
          {
            clr_line_yx(5,0);
            printf(" Sekundr - Leerlaufspannung (V) =  ");
            ena_curs();
            error = !scanf("%lf",&vsek_o);
            rewind(stdin);
            dis_curs();
          }
          while(bell(error || vsek_o <= vsek_n ));
          
          verlustf = vsek_o / vsek_n;
        }
        
      }

      if(verlustf >= 1)                                /* --- Rechnen --- */
      {
        vsek_o = vsek_n * verlustf;          /* Leerlauf-Sekundrspannung */
        ri = ((pow(vsek_n,2)) / p_trf) * (verlustf - 1);  /* Innenwiderst.*/
        c_lad = (i_last / (2 * v_ss * 50)) * 
                (1 - (sqrt(sqrt(ri / (2 * (v_mit / i_last)))))); 
        c_lad *= 1000000L;                             /* weil Wert in yF */

        cls_yx(2,0);  revrs_curs();                  /* --- Auswerten --- */
        puts(" Vollstndige Resultate mit Ladeelko ... ");  
        norm_curs();    puts("");
        netzt_1_auswertung(v_max, v_mit, v_min, vsek_n, p_trf);
        netzt_2_auswertung(v_ss, ri, vsek_o, c_lad, v_reg, 
                           v_drop, i_last, netztol_p);
        repeat_quest(ON);   
        break_quest(ON);      
        key = getch();
      }
    }
  }
  while(key!='q');

  key = 0;
}

/**************************************************************************/

void sekimpuls(void)
{
  double u1 = 0, u2 = 0, r2 = 0, i1 = 0, i2, c = 0, ri, t, ik; 
  int error = FALSE;

  do
  {
    cls();
    revrs_curs();
    puts(" Berechnung des Einschaltimpulses bei Trafo-Gleichrichter-     ");
    puts(" Kondensatorschaltung (Worst-Case).                            ");
    puts(" Grundlagen aus ELEKTOR 4/90  Seite 62   Thema: 'SICHERUNGEN'. ");
    norm_curs();


    do
    {
      clr_line_yx(4,0);     
      printf(" Trafo - Leerlaufspannung in (V eff):   ");
      ena_curs();
      error = !scanf("%lf",&u1);
      dis_curs();
      rewind(stdin);
      u1 = u1 * sqrt(2);              /* Leerlauf Sinus-Peakwert */
    }
    while(bell(error || u1==0));
  
  
    do
    {
      clr_line_yx(5,0);     
      printf(" Trafo - Spannung belastet (V eff):     ");
      ena_curs();
      error = !scanf("%lf",&u2);
      dis_curs();
      rewind(stdin);
      u2 = u2 * sqrt(2);              /* Sinus-Peakwert belastet */
    }
    while(bell(error || u2==0));

    break_quest(ON);
  
    pos_curs(8,0);
    revrs_curs();    
    puts(" Whle:  Eingabe des Last-Stromes <i> oder Eingabe des Lastwiderstandes <r>. ");
    norm_curs();
    do  { key = getch(); } while(key!='i' && key!='r' && key!='q');

    if(key=='q')    break;
    break_quest(OFF);


    if(key=='r')
    {
      do
      {
        clr_line_yx(10,0);  
        printf(" Lastwiderstand (Ohm):  ");
        ena_curs();
        error = !scanf("%lf",&r2);
        rewind(stdin);
        dis_curs();
      }
      while(bell(error || r2==0));  
        
      i2 = u2 / r2;
    }
    else if(key=='i')
    {
      do
      {
        clr_line_yx(10,0);
        printf(" Last-Gleichstrom (Amp):  ");
        ena_curs();
        error = !scanf("%lf",&i2);
        rewind(stdin);
        dis_curs();
      }
      while(bell(error || i2==0));
    }   
  
  
    do
    {
      clr_line_yx(11,0);
      printf(" Kapazitt (in %cF):  ",MUE);
      ena_curs();
      error = !scanf("%lf",&c);
      rewind(stdin);
      dis_curs();
    }
    while(bell(error || c==0));

  
    c = c / 1000000L;                       /* wegen Eingabe in yF   */
    i1 = u1 / 10000000L;                  /* Elco - Worstcase      */
    ri = -(u2 - u1) / (i2 - i1);          /* Trafo-Innenwiderstand */
    if(ri==0) { error = TRUE;   div_zero(); }


    if(error!=TRUE)
    {
      ik = u1 / ri;          /* Kurzschlusstrom, max. Einschaltstrom */
      t = ri * c;
    }

    pos_curs(12,0);
    puts("---------------------------------------------------------------");
    pos_curs(13,50);   revrs_curs();    puts(" Resultate ");   norm_curs();
    
    if(error!=TRUE)
    {
      if(ri<0 || ik<0 || t<=0)
      {
         revrs_curs();  
         pos_curs(15,20);   puts("                                 ");
         pos_curs(16,20);   puts("    Sinnlose Resultate !!!       ");
         pos_curs(17,20);   puts("                                 ");
         norm_curs();
      }
      else
      {
        printf(" Innenwiderstand  Ri =  %3.4lf Ohm\n",ri);
        printf(" Kurzschlusstrom  Ik =  %4.4lf Amp\n",ik);
        printf(" Zeitkonstante    t  =  %4.4lf ms\n",(t * 1000)); 
        printf(" Ladezeit  (t * 5)   =  %4.4lf ms\n",(t * 5000)); 
      }
    }

    repeat_quest(ON);
    break_quest(ON);
    key = getch();
  }
  while(key!='q');
  
  key = 0;
}

/**************************************************************************/

void r_toleranz(void)
{
  int toler, e_reihe, error = 0;
  double e_step;

  do
  {
    cls();
    revrs_curs();
    puts("       Normierte Widerstandswerte der E6- bis E96 - Reihe.      ");
    puts("       ---------------------------------------------------      ");
    puts("                                                                ");
    puts("       E96   1 Prozent:       Drcke ' 1' und 'CR'.             ");
    puts("       E48   2 Prozent:       Drcke ' 2' und 'CR'.             ");
    puts("       E24   5 Prozent:       Drcke ' 5' und 'CR'.             ");
    puts("       E12  10 Prozent:       Drcke '10' und 'CR'.             ");
    puts("       E 6  20 Prozent:       Drcke '20  und 'CR'.             ");
    pos_curs(24,0);
    printf("  Programm verlassen:    Drcke '0' und 'CR'. ");
    norm_curs();    

    do
    {
      clr_line_yx(9,0);
      printf(" Eingabe: ");
      ena_curs();
      error = !scanf("%d",&toler);
      dis_curs();
      rewind(stdin);
    }
    while((toler!=0 && toler!=1 && toler!=2 && toler!=5 && toler!=10 &&
          toler!=20) || bell(error)); 

    switch(toler)
    {
      case 1:   e_reihe = 96;   break;
      case 2:   e_reihe = 48;   break;
      case 5:   e_reihe = 24;   break;
      case 10:  e_reihe = 12;   break;
      case 20:  e_reihe =  6;   break;  
    }


    e_step = r_toler(e_reihe);     /* Makro: 96-te ... 6-te Wurzel aus 10 */

    if(toler!=0)    write_r_toler(e_reihe, toler, e_step);
  }
  while(toler!=0 && key!='q');          /* 'q' aus 'write_r_toler(...)' */

  key = 0;
}

/**************************************************************************/

void blindw(void)                     /* Berechnung des Blindwiderstandes */
{
  int zeile, error;
  double f, c = 0, l = 0, result, k;
  char key_buff, gesucht;
  
  do
  {
    cls();    revrs_curs();
    puts(" Die Berechnung von BLINDWIDERSTNDEN (Kapaz. und Indukt.). ");
    norm_curs();
    pos_curs(2,0);
    puts(" Frequenz in  Hz:  Taste 'h'.");
    puts("             kHz:  Taste 'k'.");
    puts("             MHz:  Taste 'm'.");
    break_quest(ON);
    
    do
    {
      key = getch();
    }
    while(key!='h' && key!='k' && key!='m' && key!='q');    

    if(key == 'q')  break;      else  break_quest(OFF);

    switch(key)
    {
      case 'h':   zeile = 3;  break;
      case 'k':   zeile = 4;  break;
      default:    zeile = 5;  break;
    }

    do
    {
      pos_curs(zeile-1,29);                   
      printf(" ----> Frequenz:  ");
      ena_curs();
      error = !scanf("%lf",&f);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error));
    
    
    switch(key)
    {
      case 'm':   f *= 1000000L;   break;
      case 'k':   f *= 1000;      break;
    }
   
    
    pos_curs(7,0);        revrs_curs();
    puts(" Kondensator:    Taste 'c'.  ");  
    puts(" Spule:          Taste 'l'.  "); 
    norm_curs();
    break_quest(ON);
    
    do
    {
      key = getch();
    }
    while(key!='c' && key!='l' && key!='q');

    if (key == 'q')   break;
    else if(key == 'C' || key == 'c')   gesucht = 'C';  
    else if(key == 'L' || key == 'l')   gesucht = 'L';  
        
    key_buff = key;

    /* ---------------------------------------------------------------- */

    if (key_buff =='C' || key_buff =='c')
    {
      pos_curs(10,0);
      puts(" Eingabe der Kapazitt in Micro-Farad:  Taste 'y'.");
      puts("                          Nano -Farad:  Taste 'n'.");
      puts("                          Pico -Farad:  Taste 'p'.");
      
      do
      {
        key = getch();
      }
      while(key!='y' && key!='n' && key!='p' && key!='q');
      

      if(key!='q')
      {
        break_quest(OFF);
      
        switch(key)
        {
          case 'y':   zeile = 11;   break;
          case 'n':   zeile = 12;   break;
          case 'p':   zeile = 13;   break;          
        }

        do
        {
          pos_curs(zeile-1,52);
          printf(" ----> Eingabe:  ");
          ena_curs();
          error = !scanf("%lf",&c);       
          dis_curs();
          rewind(stdin);
        }
        while(bell(error));


        switch(key)
        {
          case 'y':   k =       1000000L;                break;
          case 'n':   k =    1000000000L;                break;
          case 'p':   k =    1000000000L;   c /= 1000;   break;
        }


        if(f * c != 0)
        {
          result = k / (kreisfrq(f) * c);
          result_blindw(result,gesucht);  
          repeat_quest(ON);
          break_quest(ON);
          key = getch();
        }
        else    div_zero();
      }
    }
 
    /* ---------------------------------------------------------------- */

    if(key_buff=='L' || key_buff=='l')
    {
      pos_curs(10,0);
      puts(" Engabe der Kapazitt in       Henry:  Taste 'h'.");
      puts("                         Milli-Henry:  Taste 'm'.");
      puts("                         Mikro-Henry:  Taste 'y'.");
      break_quest(ON);
     
       do
      {
        key = getch();
      }
      while(key!='h' && key!='m' && key!='y' && key!='q');
     
      if(key != 'q')
      {
        break_quest(OFF);
        
        switch(key)
        {
          case 'h':   zeile = 11;   break;
          case 'm':   zeile = 12;   break;
          default:    zeile = 13;   break;
        }
        

        do
        {
          pos_curs(zeile-1,52);
          printf(" ----> Eingabe:  ");
          ena_curs();
          error = !scanf("%lf",&l);
          dis_curs();
          rewind(stdin);
        }
        while(bell(error));
    

        switch(key)
        {
          case 'y':   l /= 1000000L;   break;
          case 'm':   l /= 1000;      break;
        }

        result = kreisfrq(f) * l;
        result_blindw(result, gesucht);     
        repeat_quest(ON);
        break_quest(ON);
        key = getch();
      }
    }
  }
  while(key != 'q');
  key = 0;
}

/**************************************************************************/

void c_voltage(void)                /* Berechnung der Kondensatorspannung */
{
  double v;
  int error;
  
  do
  {                           
    catchkey();
    cls();
    revrs_curs();
    puts("   Kondensatorspannung als Funktion von T, R und C.    ");
    norm_curs();

    if(key != 'g')
    {
      do
      {
        pos_curs(5,0);
        revrs_curs();
        puts(" Defaultwert = 0.63212...  { 1-exp(-1) } ? ");
        puts(" Gebe den Wert Null ein !                  ");
        norm_curs();
        
        do
        {
          pos_curs(2,0);
          printf(" Eingabe des Spannungsverhltnis   'U (C) / U' :  ");
          stor_curs();
          ena_curs();
          error = !scanf("%lf",&v);
          dis_curs();
          rewind(stdin);
        }
        while(bell(error));
        
        if(v==0)  v = 1-exp(-1);   /* Defaulteingabe mit Null: 0.63212... */
        restor_curs();  printf("%lf",v);
      }
      while(v>=1);
    }
    else
    {
      pos_curs(2,0);  
      printf(" Spannungsverhltnis  'U (C) / U' :  %lf\n",v);
    }


    pos_curs(4,0);
    puts(" Gesucht wird ....                         ");
    puts(" ------------------                        ");
    puts(" -T bei gegebenem R und C:     Drcke 't'. ");
    puts(" -R bei gegebenem T und C:     Drcke 'r'. ");
    puts(" -C bei gegebenem T und R:     Drcke 'c'. ");
                                                                
    do
    {
      key = getch();
    }
    while(key!='t' && key!='r' && key!='c' && key!='q');
    
    
    switch(key)               /*  Sub-Subfunktionen-Aufruf */
    {
      case 't':   time1(v);      break;
      case 'r':   resist(v);    break;
      case 'c':   capac(v);     break;
    }
  }
  while(key != 'q');

  key=0;
}

/**************************************************************************/

void par_res(void)           /*  Berechnung von Parallelwiderstnden  */
{
  int n, i, error;
  double rx; 
  double r[10];     /* Maximal 10 Parallelwiderstnde */
  
  do
  {
    catchkey();     error = FALSE;
    cls();
    revrs_curs();
    puts("   Berechnung  von  Parallelwiderstnden (max. 10) .  ");
    norm_curs();

    do
    {
      clr_line_yx(3,0);
      printf(" Anzahl parallel geschalteter Widerstnde =  ");
      ena_curs();
      error = !scanf("%d",&n);
      dis_curs();
      rewind(stdin);
    }
    while(bell(error || n>10 || n<1));

    pos_curs(5,0);
    revrs_curs();
    puts(" Gesucht  R-Total  oder  R0:      Taste 't'  oder  'n'. ");
    norm_curs();
    repeat_quest(ON);
    break_quest(ON);
    key = getch();        /* Falsche Eingaben werden erkannt! */
    repeat_quest(OFF);
    break_quest(OFF);
 
 
    if(key=='t' || key=='n')
    {
      pos_curs(7,0);  
                                
      for(i=0; i<n; i++)
      {
        if(key=='n' && i==0)     printf(" Widerstand R tot =  ");
        else    printf(" Widerstand R(%d) =  ",i);
        ena_curs();
        scanf("%lf",&r[i]);
        dis_curs();
        rewind(stdin);
      }

      puts("");
      revrs_curs();             
      
      switch(key)                            /* --- Rechenoperationen --- */
      {
        case 't':   rx = 0;
                    
                    for(i=0; i<n; i++)
                    {
                      rx = (rx + 1 / r[i]);
                      if(r[i]==0)   { div_zero();   error = TRUE; }
                    }
                    
                    if(error != TRUE)  printf(" Totalwiderstand  Rtot =  ");     
                    break;
                    
        case 'n':   if(r[0]==0)     { div_zero();     error = TRUE; }
                    rx = (1 / r[0]);
                    
                    for(i=1; i<n; i++)
                    {
                      rx = (rx - 1 / r[i]);
                      if(r[i]==0)   { div_zero();   error = TRUE; }
                    }
                    
                    if(error != TRUE)   printf(" Teilwiderstand  Ro =  ");        
                    break;
      }
      
      if(error != TRUE)
      {
        printf("%4.4lf",1/rx);
        if((1/rx)<0)  
          { bell(TRUE);  puts("  Widerstand ist nicht real !"); }
        repeat_quest(ON);
        break_quest(ON);
        norm_curs();
        key = getch();
      }
    }
  }  
  while(key != 'q');

  key = 0;
}

/**************************************************************************/

void slew_rate(void)              /* Berechnung von Slerate, fmax, U peak */
{
  double freq, volt, slewrate;
  int error, line_number;
  
  do
  {
    catchkey();
    cls();
    revrs_curs();
    puts("   Operationsverstrker:  Berechnung der SLEW-RATE.");
    norm_curs();
    pos_curs(4,0);
    puts(" Gesucht ist die SLEW-RATE in Volt/Mikrosekunden:    Taste 's'.");
    puts(" Gesucht ist die Maximale Frequenz:                  Taste 'f'.");
    puts(" Gesucht ist die Maximale Amplitude (U peak) :       Taste 'v'.");
    puts("");   puts("");
    revrs_curs();
    puts("                                                                  ");
    puts("  -------------------------------------------------------------   ");
    puts(" |   Grundformel:    slewrate   =   2  *  PI  *  f  *  U peak  |  ");
    puts("  -------------------------------------------------------------   ");
    puts("                                                                  ");
    norm_curs();
    break_quest(ON);
    
    do
    {
      key = getch();
    }
    while(key!='s' && key!='f' && key!='v' && key!='q');
    
    
    switch(key)
    {
      case 's':   /* Es folgt: Die Zeilen 'Gesucht ist...' und */
      case 'f':   /*           Formel lschen.                 */
      case 'v':   pos_curs(4,0);  
                  for(line_number=0; line_number<=9; line_number++)  
                    { clr_line_cr(); }            /* Bildbereich lschen  */
                  break_quest(OFF); 
                  pos_curs(4,0);              /* Startline der Berechnung */
                  stor_curs();
    }
    
    
    switch(key)
    {
      case 's':
        do
        {
          do
          {
            restor_curs();
            printf(" Maximale FREQUENZ (kHz)        QUIT=0   :  ");
            ena_curs();
            error = !scanf("%lf",&freq);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error));
          
          stor_curs();
          if(freq==0)   break;          
                    
          do
          {
            restor_curs();
            printf(" Maximale AMPLITUDE (V peak)    QUIT=0   :  ");
            ena_curs();
            error = !scanf("%lf",&volt);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error));

          if(volt==0)   break;

          slewrate = (2 * PI * freq * volt) / 1000;           /* Formel */
          printf(" Die minimale SLEW-RATE betrgt:  ");
          revrs_curs();
          printf(" %3.3lf Volt/Mikrosek. \n\n",slewrate);
          norm_curs();      /* oben: \n Leerzeile vor nchster Berechnung */
          stor_curs();      /* Cursorposition fr nchste Berechnung      */
        }
        while(key != 'q');
      
        key = 0;    break;  
                              /* ----- case - limit ----- */
      case 'f':
        do
        {
          do
          {
            restor_curs();
            printf(" SLEW-RATE  (Volt/Mikrosek.)    QUIT=0   :  ");
            ena_curs();
            error  = !scanf("%lf",&slewrate);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error));
      
          stor_curs();    
          if(slewrate == 0)     break;
          
          do
          {
            restor_curs();
            printf(" Maximale AMPLITUDE (V peak)    QUIT=0   :  ");
            ena_curs();
            error = !scanf("%lf",&volt);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error));

          if(volt == 0)      break;

          freq = (1000 * slewrate) / (2 * PI * volt);           /* Formel */
          printf(" Die maximale FREQUENZ betrgt:  ");  
          revrs_curs();
          printf(" %5.3lf kHz \n\n",freq);
          norm_curs();      /* oben: \n Leerzeile vor nchster Berechnung */
          stor_curs();      /* Cursorposition fr nchste Berechnung      */
        }
        while(key != 'q');

        key = 0;      break;
                              /* ----- case - limit ----- */
      case 'v':
        do
        {
          do
          {
            restor_curs();
            printf(" SLEW-RATE  (Volt/Mikrosek.)    QUIT=0   :  ");
            ena_curs();
            error = !scanf("%lf",&slewrate);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error));
            
          stor_curs();
          if(slewrate == 0)     break;
          
          do
          {
            restor_curs();
            printf(" Maximale FREQUENZ (kHz)        QUIT=0   :  ");
            ena_curs();
            error = !scanf("%lf",&freq);
            dis_curs();
            rewind(stdin);
          }
          while(bell(error));
          
          if(freq == 0)     break;
          volt = (1000 * slewrate) / (2 * PI * freq);           /* Formel */
          printf(" Die maximale AMPLITUDE betrgt:  ");
          revrs_curs();
          printf(" %3.3lf V peak \n\n",volt);
          norm_curs();      /* oben: \n Leerzeile vor nchster Berechnung */
          stor_curs();      /* Cursorposition fr nchste Berechnung      */
        }
        while(key != 'q');
      
        key = 0;    break;
                                /* ----- case - end ----- */
    }
  }
  while(key != 'q');

  key = 0;
}

/**************************************************************************/
/**************************************************************************/
/********************     H A U P T  - P R O G R A M M    *****************/

void main()
{
  do
  {            
    do
    {
      catchkey();      /* Leeren eines evtl. nicht leeren Tastaturpuffers */
      dis_curs();
      cls();
      revrs_curs();
      puts("       Verschiedene   ELEKTRONIK  -  Berechnungsroutinen.          ");
      puts("       Aus EC-WOCHE (in Basic) und eigener Kche.                  ");
      puts("       Programmiert in TURBO-C.   Th.Schaerer 04.90 / 11.97        ");
      norm_curs();
      pos_curs(4,0);
      puts(" Blindwiderstnde von Kapazitten und Induktivitten:   Taste 'b'.");
      puts("");
      puts(" Berechnung von Parallelwiderstnden (max. 10):         Taste 'p'.");
      puts("");
      puts(" Toleranztabelle fr Widerstnde (1 - 20%):             Taste 't'.");
      puts("");
      puts(" Kondensatorspannung als Funktion von T, R und C:       Taste 'c'.");
      puts("");
      puts(" Einschaltimpuls  Trafo-Sek --> Gleichr. --> Kond.:     Taste 'i'.");
      puts("");
      puts(" Netzteil  Trafo --> Gleichr. --> Sieb. --> Regler:     Taste 'n'.");
      puts(""); 
      puts(" Operationsverstrker:  Slewrate / Bandb. / Spannung:   Taste 's'.");
      revrs_curs();
      pos_curs(23,0);
      printf("   P r o g r a m m   verlassen ?          ");
      break_quest(ON);
      norm_curs();

      do
      {
        key = getch();
      }
      while( key!='b' && key!='c' && key!='p' && key!='s' && key!='i' &&
             key!='t' && key!='n' &&key!='q');

      switch(key)
      {
      case 'b':   blindw();     break;
      case 'c':   c_voltage();  break;
      case 'p':   par_res();    break;
      case 's':   slew_rate();  break;
      case 't':   r_toleranz(); break;
      case 'i':   sekimpuls();  break;
      case 'n':   netzteil();   break;
      }
    }
    while(key != 'q');    
  }
  while(key != 'q');
  
  cls();
  exit(0);
}

/**************************************************************************/
/**************************************************************************
Bemerkungen zu diesem C-bungsprogramm:
---------------------------------------

- Die jeweils letzte break-Anweisung einer switch-Verzweigung hat nur 
  sthetischen Karakter.
  
- Wahrscheinlich hat dieses Programm eine kritische Grsse, wo man sich
  berlegen muss, ob es nicht sinnvoller wre, die einzelnen Teilprogramme
  in einzelne linkfhige Objektcodes aufzuteilen. Auf was man dabei beson-
  ders achten muss, was man im vorliegenden Programm ndern sollte und 
  wo man reinfallen kann, wre Gegenstand einer Diskussion...
  
- Es hat viele puts-Befehle in Tabellen. Dass dies auch anders geht, weiss
  ich von frher. Ich hatte jetzt einfach kein Interesse an dieser String-
  operation.



 **************************************************************************/
/**************************************************************************/
/**************************************************************************/
