************************************************************************

                        F I L T C O O K . P R G
                        =======================

Programm zur Berechnung   aktiver  Tiefpass-  und  Hochpassfilter  zwei-
ter bis sechster Ordnung als Bessel, Butterworth und Tschebyscheff.

========================================================================

File:                   FILTCOOK.GFA  (GFA-3.5-BASIC)

Programmiert durch:     Thomas Schaerer (CH-Effretikon)
                        schaerer@isi.ee.ethz.ch

Grundlage:              AKTIV-FILTER-KOCHBUCH von Don Lancaster
                        (nicht mehr erhaeltlich!)

Systemvorausetzung:     ATARI-ST oder Emulation (TOSBOX) mit TOS-1.04
                        Monitoraufloesung: 600x400 High-Resolution

Datum der PD-Freigabe:  Dezember 1998

Erweiterung:            Oktober  2003 (Filter 3. und 5. Ordnungen)
                        (Der Text ist angepasst.)                        

------------------------------------------------------------------------

Was kann dieses Programm?
-------------------------
Viele  Elektroniker der etwas aelteren Generation kennen  und  schaetzen 
sicher das ausserordentlich praxisorientierte AKTIVE-FILTER-KOCHBUCH von 
Don Lancaster.  Die erste Auflage geht zurueck auf das Jahr  1982.  Seit 
1983  benutze ich dieses Buch,  wenn es darum geht rasch ein Tief-  oder 
Hochpassfilter  zweiter bis sechster Ordnung,  als  Bessel,  Butterworth 
oder Tschebyscheff,  zu entwerfen.  Wegen der Skalierung auf 1 kHz,  ist 
die Berechnung besonders leicht gemacht.  

Nach  erfolgter Berechnung kann die ganze Seite im unkomprimierten  PIC-
Format gespeichert werden.  Bei ersten Speichervorgang wird der Name auf 
BILD1.PIC  gesetzt.  Mit  jeder weiteren Bildspeicherung wird  die  Zahl 
(BILD2.PIC, BILD3.PIC, ...) incrementiert. Man kann in der Filesektorbox 
allerdings auch andere Namen einsetzen.  Nach der Speicherung mit  einem 
andern  Namen wird fuer die folgende Speicherung allerdings  erneut  auf 
BILDx.PIC gesetzt, wobei x incrementiert wurde.


Wer kann dieses Programm anwenden?
----------------------------------
Jedermann  der die notwendigen Grundlagen in der  elektronischen  Schal-
tungstechnik  besitzt.  Man  muss dazu nicht im Besitze  des  erwaehnten 
Buches sein,  obwohl es sich natuerlich lohnen wuerde. Schliesslich geht 
das  Buch  wesentlich weiter als dieses einfache  Programm  bietet.  Die 
deutschsprachige  Version gibt es allerdings nicht  mehr.  Falls  jemand 
fragen moechte,  ob ich bereit waere das Buch gegen Entgeld zu kopieren, 
die Antwort lautet Nein!

Beispiel:  Wenn jemand einfach ein Tiefpassfilter,  z.B. zwecks Antiali-
asing-Tiefpassfilter fuer ein AD-Wandlersystem realisieren muss und  mit 
der 1dB-Tschebyscheffcharakteristik und einer Grenzfrequenzsteilheit von 
etwa 57 dB pro Oktave zufrieden ist, genuegt dieses Programm. Man waehlt 
die Dimensionierung eines Tiefpassfilters sechster Ordnung und gibt  den 
Grenzfrequenzwert  und  den  C-Wert (bei allen  Stufen  identisch)  ein. 
Berechnet werden dann die R-Werte.


Einige technische Angaben
-------------------------
Die  Tief-  und Hochpassfilter,  welche hier berechnet  werden  koennen, 
haben alle eine Verstaerkung die groesser ist als Eins. Die Verstaerkung 
steigt mit zunehmender Ordnung,  aber auch mit abnehmender Daempfung. Am 
unteren Ende der Verstaerkung hat ein  Tief- oder Hochpassfilter zweiter 
Ordnung mit Bessel-Charakteristik eine Verstaerkung von 1.3 (2.3 dB) und 
mit Tschebyscheff eine von 2.0 (6.0 dB).   Am oberen Ende der  Verstaer-
kung  hat  ein  Tief- oder Hochpassfilter sechster Ordnung  mit  Bessel-
Charakteristik hat eine Verstaerkung von 2.9 (9.3 dB) und  mit  Tscheby-
scheff eine von 12.3 (21.8 dB).

Diesem Nachteil steht der Vorteil gegenueber,  dass man in allen Filter-
segmenten  die  selben frequenzbestimmenden  Kondensatorwerte  einsetzen 
kann.  Dies  macht die Realisierung der Filterschaltung  enorm  einfach. 
Besonders bei hochgenauen z.B.  einprozentigen C-Werten erleichtert dies 
die  Beschaffung enorm.  Die Verstaerkung der Schaltung ist nicht  immer 
von  Nachteil.  Naemlich dann nicht,  wenn die Verstaerkung der  Filter-
schaltung  einen  Teil der Gesamtverstaerkung des  Systemes  uebernehmen 
kann. Will man trotzdem eine Filterverstaerkung von exakt Eins, muss man 
der  Filterschaltung eine kleine Opampschaltung voschalten,  welche  das 
Eingangssignal  mit  dem selben Betrag  daempft,  wie  die  nachfolgende 
Filterschaltung  verstaerkt.  Das Bild BEISPIEL.GIF (BEISPIEL.PAC) zeigt 
ein praktisches Beispiel einer solchen Anwendung.

Bei  den Tief- und Hochpassfiltern dritter und fuenfter Ordnung hat  der 
Widerstand RD1 keine verstaerkungs-,  bzw.  daempfungsbestimmende  Funk-
tion.  Man koennte bei diesem ersten Opamp gerade so gut den Ausgang mit 
dem  invertierenden  Eingang kurzschliessen.  Darum liest  man  auch  im 
Programm  'irrelevant' oder 'Null Ohm'.  Man liest aber auch  'RD1=RF1'. 
Dies  gilt  vor  allem fuer aeltere bipolare Opamps  mit  relativ  hohen 
Eingangs-Biasstroemen.  Waehlt  man an beiden Opampeingaengen  etwa  die 
gleich  hohen Quellwiderstaende (nicht Quellimpedanzen),  wird der  Off-
seteffekt etwas reduziert.



Datei-Ordnung
-------------
______FILTCOOK/
          |     
          |_____FILTCOOK.MAN   (Manual ASCII-Datei)
          |_____FILTCOOK.DOC   (Manual First-Word-Plus-Datei)
          |_____FILTCOOK.GFA   (GFA-3.5-BASIC-Quelltext)
          |_____FILTCOOK.LST   (dito. als ASCII-Datei)
          |_____STADDEC.INL    (INLINE-Code fuer STAD-Bildlese-Funktion)
          |_____FILTCOOK.PRG   (Ausfuehrbares Programm)
          |_____STARTPIC.PAC   (Startbild)
          |_____TP_2.PAC       (Bild: Tiefpassfilter 2. Ordnung)
          |_____TP_3.PAC       (Bild: Tiefpassfilter 3. Ordnung)
          |_____TP_4.PAC       (Bild: Tiefpassfilter 4. Ordnung)
          |_____TP_5.PAC       (Bild: Tiefpassfilter 5. Ordnung)
          |_____TP_6.PAC       (Bild: Tiefpassfilter 6. Ordnung)
          |_____HP_2.PAC       (Bild: Hochpassfilter 2. Ordnung)
          |_____HP_3.PAC       (Bild: Hochpassfilter 3. Ordnung)
          |_____HP_4.PAC       (Bild: Hochpassfilter 4. Ordnung)
          |_____HP_5.PAC       (Bild: Hochpassfilter 5. Ordnung)
          |_____HP_6.PAC       (Bild: Hochpassfilter 6. Ordnung)
          |_____BEISPIEL.GIF   (Schaltbild ist Teil dieses Manual)
          |_____BEISPIEL.PAC   (dito. jedoch STAD/PAC-Format)


Autor:  Thomas Schaerer 
        CH-8307 Effretikon 
        E-Mail: schaerer@isi.ee.ethz.ch 
        WWW:    http://www.elektronik-kompendium.de/public/schaerer/

Datum und Ort:  20.12.1998 ; 05.10.2003
 
-eof- 

